
using System;
using System.Collections.Generic;
using System.Collections;
using System.IO;
using UnityEngine;
using UnityEngine.UI;
using System.Linq;
using TMPro;
using UnityEngine.Events;
using UnityEngine.SceneManagement;

// +-----------------------------------------------------------------------------+
// | |       |\                                           -~ /     \  /          |
// |~~__     | \                                         | \/       /\          /|
// |    --   |  \                                        | / \    /    \     /   |
// |      |~_|   \                                   \___|/    \/         /      |
// |--__  |   -- |\________________________________/~~\~~|    /  \     /     \   |
// |   |~~--__  |~_|____|____|____|____|____|____|/ /  \/|\ /      \/          \/|
// |   |      |~--_|__|____|____|____|____|____|_/ /|    |/ \    /   \       /   |
// |___|______|__|_||____|____|____|____|____|__[]/_|----|    \/       \  /      |
// |  \mmmm :   | _|___|____|____|____|____|____|___|  /\|   /  \      /  \      |
// |      B :_--~~ |_|____|____|____|____|____|____|  |  |\/      \ /        \   |
// |  __--P :  |  /                                /  /  | \     /  \          /\|
// |~~  |   :  | /                                 ~~~   |  \  /      \      /   |
// |    |      |/                        .-.             |  /\          \  /     |
// |    |      /                        |   |            |/   \          /\      |
// |    |     /                        |     |            -_   \       /    \    |
// +-----------------------------------------------------------------------------+
// |          |  /|  |   |  2  3  4  | /~~~~~\ |       /|    |_| ....  ......... |
// |          |  ~|~ | % |           | | ~J~ | |       ~|~ % |_| ....  ......... |
// |   AMMO   |  HEALTH  |  5  6  7  |  \===/  |    ARMOR    |#| ....  ......... |
// +-----------------------------------------------------------------------------+
// Anyone who doesn't put useless aski art at the start of their code, doesn't have a brain.

namespace Mod
{
    public class Mod
    {

        public const float PixelSize = Global.MetricMultiplier / 35f; //useful later

        public static void OnLoad()
        {
            Config.Config_Setup(); //sets up the config.
            AssetLoadup.Init(); //loads assets.
            SceneManager.activeSceneChanged += ChangedActiveScene;
            ModAPI.RegisterInput("NHC Controller Left", AssetLoadup.KeyLeft, KeyCode.A);
            ModAPI.RegisterInput("NHC Controller Right", AssetLoadup.KeyRight, KeyCode.D);
            ModAPI.RegisterInput("NHC Controller Up", AssetLoadup.KeyUp, KeyCode.W);
            ModAPI.RegisterInput("NHC Controller Main Action", AssetLoadup.KeyMain, KeyCode.O);
            ModAPI.RegisterInput("NHC Controller Alt Action", AssetLoadup.KeyAlt, KeyCode.P);
        }

        public static void ChangedActiveScene(Scene scene, Scene next)
        {
            if (next.name == "Main"){ //main scene-load
                foreach (TextMeshProUGUI TextObj in UnityEngine.GameObject.FindObjectsOfType<TextMeshProUGUI>()){ //for every text object in the scene!
                    if(TextObj.text == "Clear everything"){ //code for the Clear NHC button
                        GameObject Button = TextObj.gameObject.transform.parent.gameObject;

                        //clones the Clear button and replaces it with everything needed for the nhc clear button
                        GameObject NewButton = UnityEngine.GameObject.Instantiate(Button, Button.transform.parent.gameObject.transform);
                        NewButton.transform.localPosition = new Vector3(0,0);
                        UnityEngine.GameObject.Destroy(NewButton.GetComponent<ClearLivingBehaviour>());
                        UnityEngine.UI.Button ButtonBehav = NewButton.GetComponent<Button>();

                        ClearNHCButton TheHNCClearComp = NewButton.AddComponent<ClearNHCButton>();
                        TextMeshProUGUI TheTextChild = NewButton.GetComponentInChildren(typeof(TextMeshProUGUI)) as TextMeshProUGUI;
                        HasTooltipBehaviour TooltipBehaviour = NewButton.GetComponentInChildren(typeof(HasTooltipBehaviour)) as HasTooltipBehaviour;

                        ButtonBehav.onClick.SetPersistentListenerState(0, UnityEventCallState.Off);
                        ButtonBehav.onClick.AddListener(TheHNCClearComp.Clear);
                        TheTextChild.text = "Clear NHCs";
                        TooltipBehaviour.Text = "Clears Non-Human Characters (NHCs)";


                        Debug.Log("THING PARENT x " + TextObj.gameObject.transform.parent.gameObject.transform.localPosition.x + " y " + TextObj.gameObject.transform.parent.gameObject.transform.localPosition.y);
                        Debug.Log("THING PARENT PARENT x " + TextObj.gameObject.transform.parent.gameObject.transform.parent.gameObject.transform.localPosition.x + " y " + TextObj.gameObject.transform.parent.gameObject.transform.parent.gameObject.transform.localPosition.y);
                        //Debug.Log("THING PARENT PARENT PARENT x " + TextObj.gameObject.transform.parent.gameObject.transform.parent.gameObject.transform.parent.gameObject.transform.localPosition.x + " y " + TextObj.gameObject.transform.parent.gameObject.transform.parent.gameObject.transform.parent.gameObject.transform.localPosition.y);
                    }
                }
                if ((Canvas) GameObject.FindObjectOfType(typeof(Canvas)) != null) //set canvas assetloadup ..
                {AssetLoadup.Canvas = (Canvas) GameObject.FindObjectOfType(typeof(Canvas));}else{
                    Debug.Log("NHC Mod canvas check returned null!?");
                }
            }
            //Debug.Log("NHC Mod scene Load Detected : " + next.name);
        }

        public static void Main()
        {
			ModAPI.RegisterPower<NHCRevivePower>(
				"NHC Revive",
				"Revives Dead NHCs and Heals Living ones.",
				ModAPI.LoadSprite("chars/icons/revive_icon.png")
			);

            classicCB.Create("HNC", "Non-ragdoll NPC's and AI framework", ModAPI.LoadSprite("caticon.png", 2));

            SetupNHCs(); //everything else mostly.
        }

        public static void SetupNHCs(){
            RegistSimpleNHC(
                "Friendly Human",
                "Passive simple human NHC that walks around randomly",
                "!human!friendly",
                "char_human_icon",
                new string[] {
                    "Walking_Random",
                    "Falling",
                    "Damage_FromEnvo",
                    "Damage_FromShot"
                }
            );
            RegistSimpleNHC(
                "Talkative Human",
                "Passive simple human NHC that walks around randomly and talks",
                "!human!talkative",
                "char_human_icon_talk",
                new string[] {
                    "Walking_Random",
                    "Falling",
                    "Damage_FromEnvo",
                    "Damage_FromShot",
                    "Talking"
                }
            );
            RegistSimpleNHC(
                "Named Human",
                "Passive simple human NHC that walks around randomly and has a Common Name",
                "!human!named",
                "char_human_icon_name",
                new string[] {
                    "Walking_Random",
                    "Falling",
                    "Damage_FromEnvo",
                    "Damage_FromShot",
                    "Names_Common",
                    "NameTags"
                }
            );
            RegistSimpleNHC(
                "Gunner Human",
                "Simple human NHC that walks around and Shoots a GUN!",
                "!human!gunner",
                "char_human_icon_gun",
                new string[] {
                    "Walking_Random",
                    "Falling",
                    "Damage_FromEnvo",
                    "Damage_FromShot",
                    "Attack_Gun_Random"
                }
            );
            RegistSimpleNHC(
                "Named Gunner Human",
                "Human NHC that walks around, Shoots a Gun and has a Name!",
                "!human!gunnernamed",
                "char_human_icon_gun_name",
                new string[] {
                    "Walking_Random",
                    "Falling",
                    "Damage_FromEnvo",
                    "Damage_FromShot",
                    "Attack_Gun_Random",
                    "Names_Common",
                    "NameTags"
                }
            );
            RegistSimpleNHC(
                "Named Gunner Human (PVP)",
                "Human NHC that walks around, Shoots a Gun, has a Name and can Shoot other NHCs!",
                "!human!gunnerPVPnamed",
                "char_human_icon_gun_name_pvp",
                new string[] {
                    "Walking_Random",
                    "Falling",
                    "Damage_FromEnvo",
                    "Damage_FromShot",
                    "Damage_FriendlyFire",
                    "Attack_Gun_Random",
                    "Names_Common",
                    "NameTags"
                }
            );
            RegistSimpleNHC(
                "Gunner Human (PVP)",
                "Human NHC that walks around, Shoots a Gun and can Shoot other NHCs!",
                "!human!gunnerPVP",
                "char_human_icon_gun_pvp",
                new string[] {
                    "Walking_Random",
                    "Falling",
                    "Damage_FromEnvo",
                    "Damage_FromShot",
                    "Damage_FriendlyFire",
                    "Attack_Gun_Random"
                }
            );
            RegistSimpleNHC(
                "Jumpy Human",
                "Passive simple human NHC that walks around and Jumps Gaps",
                "!human!jumpy",
                "char_human_icon",
                new string[] {
                    "Walking_Random",
                    "Falling",
                    "Damage_FromEnvo",
                    "Damage_FromShot",
                    "Jumping",
                    "JumpGaps"
                }
            );
            RegistSimpleNHC(
                "All Common Human",
                "Passive human NHC with all common AImodules",
                "!human!all",
                "char_human_icon_all",
                new string[] {
                    "Walking_Random",
                    "Falling",
                    "Damage_FromEnvo",
                    "Damage_FromShot",
                    "Jumping",
                    "JumpGaps",
                    "Attack_Gun_Random",
                    "Names_Common",
                    "NameTags",
                    "Talking"
                }
            );
            RegistSimpleNHC(
                "All Common Human (PVP)",
                "Human NHC with all common AImodules that can hurt other NHCs!",
                "!human!all",
                "char_human_icon_all_pvp",
                new string[] {
                    "Walking_Random",
                    "Falling",
                    "Damage_FromEnvo",
                    "Damage_FromShot",
                    "Damage_FriendlyFire",
                    "Jumping",
                    "JumpGaps",
                    "Attack_Gun_Random",
                    "Names_Common",
                    "NameTags",
                    "Talking"
                }
            );
            RegistSimpleNHC(
                "Slapping Human?!",
                "Human NHC that has an AImodule designed for slapping things that i threw together on an ADHD tangent.. slaps things... why did i make this..",
                "!human!slapping",
                "char_human_icon_slap",
                new string[] {
                    "Walking_Random",
                    "Falling",
                    "Damage_FromEnvo",
                    "Damage_FromShot",
                    "Slap_Meme"
                }
            );
        }

        public static void RegistSimpleNHC(string Name, string Description, string NameOrder, string ThumbnailTitle, string[] Aimods, float ScaleAddon = 0){
            ModAPI.Register(
                new Modification(){
                    OriginalItem = ModAPI.FindSpawnable("Brick"),
                    NameOverride = Name,
                    DescriptionOverride = Description,
                    NameToOrderByOverride = "AAA!" + NameOrder,
                    CategoryOverride = ModAPI.FindCategory("HNC"),
                    ThumbnailOverride = ModAPI.LoadSprite("chars/icons/" + ThumbnailTitle +".png", 2f),
                    AfterSpawn = (Instance) =>
                    {
                        PhysicalBehaviour PhysBehav = Instance.GetComponent<PhysicalBehaviour>();
                        PhysBehav.Properties = ModAPI.FindPhysicalProperties("Concrete");
                        float scale = UnityEngine.Random.Range((1f + ScaleAddon), (1.25f + ScaleAddon));
                        Instance.transform.localScale = new Vector2(scale, scale);
                        NHC NHC = Instance.AddComponent<NHC>();
                        NHC.ColliderSprite = ModAPI.LoadSprite("chars/char_human_col.png", 1f);

                        AImodule[] TempModules = new AImodule[] {};
                        foreach (string moduleName in Aimods) {
                            TempModules = TempModules.Concat(new[] {new AImodule(moduleName, NHC)}).ToArray();
                        };
                        NHC.AI = TempModules;
                    }
                }
            );
        }

        // ModAPI.Register(
        //         new Modification(){
        //             OriginalItem = ModAPI.FindSpawnable("Brick"),
        //             NameOverride = "Friendly Human",
        //             DescriptionOverride = "Passive, A Simple Normal Human.",
        //             NameToOrderByOverride = "AAA!human!passive",
        //             CategoryOverride = ModAPI.FindCategory("HNC"),
        //             ThumbnailOverride = ModAPI.LoadSprite("chars/icons/char_human_icon.png", 2f),
        //             AfterSpawn = (Instance) =>
        //             {
        //                 PhysicalBehaviour PhysBehav = Instance.GetComponent<PhysicalBehaviour>();
        //                 PhysBehav.Properties = ModAPI.FindPhysicalProperties("Concrete");
        //                 float scale = UnityEngine.Random.Range(1f, 1.25f);
        //                 Instance.transform.localScale = new Vector2(scale, scale);
        //                 NHC NHC = Instance.AddComponent<NHC>();
        //                 NHC.ColliderSprite = ModAPI.LoadSprite("chars/char_human_col.png", 1f);

        //                 NHC.AI = new AImodule[] {
        //                     new AImodule("Walking_Random", NHC),
        //                     new AImodule("Attack_Gun_Random", NHC),
        //                     new AImodule("Names_Common", NHC),
        //                     new AImodule("NameTags", NHC),
        //                     new AImodule("Falling", NHC),
        //                     new AImodule("Damage_FromEnvo", NHC),
        //                     new AImodule("Damage_FromShot", NHC),
        //                     new AImodule("Damage_FriendlyFire", NHC),
        //                     new AImodule("Talking", NHC)
        //                 };
        //             }
        //         }
        //     );
	}
}

// Originally uploaded by 'Abyssal Studio'. Do not reupload without their explicit permission.
