using System;
using System.Collections;
using UnityEngine;

public class NHCHealthbar : MonoBehaviour
{
    private NHC NHCHost;
    private SpriteRenderer SpriteRend;

    private void Awake(){
        NHCHost = gameObject.transform.parent.gameObject.GetComponent<NHC>();
        SpriteRend = gameObject.GetComponent<SpriteRenderer>();

        SpriteRend.sprite = AssetLoadup.HealthIcons[GetHealthStage()];
    }

    private void Update() {
        this.gameObject.transform.rotation = Quaternion.identity;
    }

    private void FixedUpdate(){
        SpriteRend.sprite = AssetLoadup.HealthIcons[GetHealthStage()];

        float boundsY = ((NHCHost.gameObject.GetComponent<Collider2D>().bounds.size.y / NHCHost.gameObject.transform.localScale.y));
        gameObject.transform.localPosition = new Vector3(0,boundsY - 1.5f);
    }

    private int GetHealthStage(){
        int HealthStage = (int) Mathf.Clamp((Mathf.Round((NHCHost.Health / NHCHost.InitHealth) * 10)), 0, 10);
        return(HealthStage);
    }
}
// Originally uploaded by 'Abyssal Studio'. Do not reupload without their explicit permission.
