using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using System;
using UnityEngine.Events;

public class NHC : MonoBehaviour
//animations are controlled by States and are generally rather powerful. also "AImodules" are also rather powerful as Imagine their like Components but are attached to the code not an object.
//AImodules, States and (Time comparison based single-tick repeating loops and checks) are the 3 major concepts that NHC is built on, Observe their code well... lmao
{

    public float Mass = 2f;
    public float MoveSpeed = 3f;
    public float MoveCheckRange = 0.45f;

    private PhysicalBehaviour PhysBehav;
    public Rigidbody2D RigBody;
    private SpriteRenderer SpriteRend;
    private NHC MC;

    public AImodule[] AI = new AImodule[]{};

    public int AniFrame = 0;
    public int AniFrameMax = 1;
    public Sprite[] AniSprites = new Sprite[] {};
    public Sprite[] AniSpritesHurt = new Sprite[] {};
    public float AniFrameTimeGoal;
    public float AniFPS = 0.5f;

    public int AIchancePool = 0;

    public string AniState = null;
    public bool AniPlaysOnce = false;
    public bool InAir = false;
    public Vector2 GunPos = new Vector2(0.75f,0.3f);
    public float GunDamage = 50f;
    public float GunAccuracy = 0.2f;
    public float GunForce = 5f;
    public bool FriendlyFire = false;
    public string[] PossibleNames = new String[1] {"Issue : Names not defined before NameTags"}; //used with AImodules related to nametags.
    public string Name;

    public float InitHealth = 230;
    public float Health = 230;
    public bool TakeDamageFromEnvo = false;
    public float EnvoDamageMulti = 2.1f;
    public bool TakeDamageFromShot = false;
    public bool DieFromEMP = false;
    public bool Dead = false;
    public bool CanJump = false;
    public bool JumpGaps = false;
    public float JumpMulti = 6.5f;

    public AudioClip[] GunSFX = AssetLoadup.SFX_Attack_Pistol;
    public AudioClip[] DamageSFX;
    public AudioClip[] DeathSFX = AssetLoadup.SFX_Average_Death;
    public AudioClip[] DefaultSFX = AssetLoadup.SFX_Average_Default;
    public AudioClip[] AttackSFX = AssetLoadup.SFX_Attack_Default;
    public AudioClip[] JumpSFX = AssetLoadup.SFX_Jump;

    public Sprite ColliderSprite;
    public Sprite[] SpriteStand = AssetLoadup.Char_Human_Stand;
    public Sprite[] SpriteStand_Hurt = AssetLoadup.Char_Human_Stand_Hurt;
    public float StandFPS = 0f;
    public Sprite[] SpriteWalk = AssetLoadup.Char_Human_Walk;
    public Sprite[] SpriteWalk_Hurt = AssetLoadup.Char_Human_Walk_Hurt;
    public float WalkFPS = 0.24f;
    public Sprite[] SpriteAttack = AssetLoadup.Char_Human_Attack;
    public Sprite[] SpriteAttack_Hurt = AssetLoadup.Char_Human_Attack_Hurt;
    public float AttackFPS = 0.15f;
    public Sprite[] SpriteDeath = AssetLoadup.Char_Human_Death; //has no hurt variant
    public float DeathFPS = 0.12f;
    public Sprite[] SpriteGun = AssetLoadup.Char_Human_Gun;
    public Sprite[] SpriteGun_Hurt = AssetLoadup.Char_Human_Gun_Hurt;
    public float GunFPS = 0.05f;
    public Sprite[] SpriteAir = AssetLoadup.Char_Human_InAir;
    public Sprite[] SpriteAir_Hurt = AssetLoadup.Char_Human_InAir_Hurt;
    public float InAirFPS = 0f;
    public Sprite[] SpriteTalk = AssetLoadup.Char_Human_Talk;
    public Sprite[] SpriteTalk_Hurt = AssetLoadup.Char_Human_Talk_Hurt;
    public float TalkFPS = 0f;

    public bool PlayerControlling = false;

    public GameObject test;

    private void Awake(){
        AniFrame = 0;
        AniFrameMax = 1;
        AniFrameTimeGoal = (UnityEngine.Time.fixedTime + AniFPS);
        AniFPS = 0.5f;
        MC = this;
        PhysBehav = gameObject.GetComponent<PhysicalBehaviour>();
        RigBody = gameObject.GetComponent<Rigidbody2D>();
        SpriteRend = gameObject.GetComponent<SpriteRenderer>();
        CreateHealthbar();

        int ObjLayer = LayerMask.NameToLayer("CollidingDebris");
        gameObject.layer = ObjLayer; //set collider stuff

        List<ContextMenuButton> ContButtonsList = PhysBehav.ContextMenuOptions.Buttons;
        var ControlButton = new ContextMenuButton(() => true, "nhccontrol", "NHC Control", "Control this NHC!", new UnityAction[1]
        {
        (UnityAction) (() => ToggleControl())
        });
        ControlButton.LabelWhenMultipleAreSelected = "NHC(s) Control";
        
        var NameInputButton = new ContextMenuButton(() => true, "nhcsetname", "NHC Set Name", "Set this NHC's Name!", new UnityAction[1]
        {
            (UnityAction) (() => Utils.OpenTextInputDialog<NHC>("", this, (System.Action<NHC, string>) ((t, v) =>
            {
                UnityEngine.Debug.Log("NAME SET TO : " + v);
                Name = v;
                // TEXTBOX.text = v;
            }), "Set Name", "Name"))
        });

        ContButtonsList.Add(NameInputButton);
        ContButtonsList.Add(ControlButton);
    }

    private void Start(){
        PlayerControlling = false;
        SpriteRend.sprite = ColliderSprite;
        gameObject.FixColliders();
        Health = InitHealth;
        SetState("Stand");
        NHCfunc.PhysSetup(PhysBehav,RigBody,Mass);
        
        gameObject.name = ("NHC-" + UnityEngine.Random.Range(10000000,99999999));
        PhysBehav.DisplayBloodDecals = false;
        if (Name == null){ //name cannot be null
            Name = gameObject.name;
        }
        //test = NHCfunc.CreateWindow();
    }

    public void ToggleControl(){
        PlayerControlling = !PlayerControlling;
        UnityEngine.Debug.Log("PLAYER CONTROLLING : " + PlayerControlling);
        if (PlayerControlling){
            Global.main.CameraControlBehaviour.CurrentlyFollowing.Add(PhysBehav);
        }else{
            Global.main.CameraControlBehaviour.CurrentlyFollowing.Remove(PhysBehav);
        }
    }

    public void SetState(string TheState){
        AniState = TheState;

        AniPlaysOnce = false;
        switch(AniState) 
        {
        case "Walk":
            AniSprites = SpriteWalk;
            AniSpritesHurt = SpriteWalk_Hurt;
            AniFPS = WalkFPS;
            break;
        case "Stand":
            AniSprites = SpriteStand;
            AniSpritesHurt = SpriteStand_Hurt;
            AniFPS = StandFPS;
            break;
        case "Gun":
            AniSprites = SpriteGun;
            AniSpritesHurt = SpriteGun_Hurt;
            AniFPS = GunFPS;
            break;
        case "InAir":
            AniSprites = SpriteAir;
            AniSpritesHurt = SpriteAir_Hurt;
            AniFPS = InAirFPS;
            break;
        case "Death":
            AniSprites = SpriteDeath;
            AniSpritesHurt = SpriteDeath;
            AniFPS = DeathFPS;
            AniPlaysOnce = true;
            break;
        case "Talking":
            AniSprites = SpriteTalk;
            AniSpritesHurt = SpriteTalk_Hurt;
            AniFPS = TalkFPS;
            break;
        default:
            ModAPI.Notify("<color=#ff35005>NHC AniState State : " + AniState + " not found</color>");
            break;
        }
        AniCheck(true);
    }

    private void CreateHealthbar(){
        GameObject Healthbar = new GameObject();
        Healthbar.AddComponent<ExistInDetailView>();
        Healthbar.transform.SetParent(gameObject.transform, false);
        Healthbar.AddComponent<SpriteRenderer>();
        Healthbar.AddComponent<NHCHealthbar>();
    }

    public void OnFragmentHit(float force){
        if (TakeDamageFromShot) DealDamage(force);
    }
    
    public void OnEMPHit(){
        if (DieFromEMP) DealDamage(float.PositiveInfinity);
    }

    public void Shot(global::Shot shot){
        if (TakeDamageFromShot) DealDamage(shot.damage);
    }

    // void OnCollisionStay2D(Collision2D col)
    // {}
    private void OnCollisionEnter2D(Collision2D col){ //envo damage
        if (TakeDamageFromEnvo){
            if (col.relativeVelocity.magnitude > (MoveSpeed + 1)){
                DealDamage((float) (col.relativeVelocity.magnitude * EnvoDamageMulti));
            }
        }
    }

    public void Use(ActivationPropagation activationPropagation){
    }

    public void DealDamage(float Damage){ //ran whenever this nhc takes damage, most of my code is Public cause I SUPPORT the idea of being able to edit this shit anywhere, fuck zooi's code lmao
        Health -= Damage;
        if(Health <= 0){
            if (!Dead){
                if (DeathSFX != null) NHCfunc.PlaySFX(DeathSFX, gameObject.transform.position);
                Dead = true;
                SetState("Death");
            }
        }else{//still alive
            if (DamageSFX != null) NHCfunc.PlaySFX(DamageSFX, gameObject.transform.position);
        }
    }

    public void Revive(){ //revives the dead and heals the living
        Health = InitHealth;
        if (Dead){
            Dead = false;
            SetState("Stand");
            NHCfunc.PlaySFX(AssetLoadup.SFX_Revive, gameObject.transform.position);
            SpriteRend.sprite = ColliderSprite;
            gameObject.FixColliders();
        }
    }

    private void FixedUpdate()
    {
        AniCheck();
        foreach (AImodule module in AI) {
            module.AImoduleTick();
        };
    }

    public void Jump(bool DoCheck = false){
        bool CanJumpRightNow = CanJump;
        if (DoCheck && CanJump){ //if the optional check is true, then if it cannot touch the ground below it- don't jump
            float FeetBounds = ((gameObject.GetComponent<Collider2D>().bounds.size.y * 0.75f) + 0.3f);
            RaycastHit2D HitObj = Physics2D.Raycast(gameObject.transform.position, -gameObject.transform.up, FeetBounds, 1 << LayerMask.NameToLayer("Objects"), -UnityEngine.Mathf.Infinity, UnityEngine.Mathf.Infinity);
            RaycastHit2D HitBounds = Physics2D.Raycast(gameObject.transform.position, -gameObject.transform.up, FeetBounds, 1 << LayerMask.NameToLayer("Bounds"), -UnityEngine.Mathf.Infinity, UnityEngine.Mathf.Infinity);
            float GapHitGoal = float.PositiveInfinity;
            if (HitBounds){ GapHitGoal = HitBounds.distance; } //gets what is the shortest distance aka the closest hit
            if (HitObj) {if (GapHitGoal > HitObj.distance) GapHitGoal = HitObj.distance;}
            if (!(GapHitGoal < (FeetBounds - 0.3f))){
                CanJumpRightNow = false;
            }
        }
        if (CanJumpRightNow && !Dead){ //also cannot be dead lol
            if (!(RigBody.bodyType == RigidbodyType2D.Static)){//if not static, then jump
            RigBody.velocity += new Vector2(0,JumpMulti);
            NHCfunc.PlaySFX(JumpSFX, gameObject.transform.position);
            }
        }
    }

    public void CreateBullet(){ //creates a "bullet"
        Vector3 PosRelToGun = new Vector3(
            (GunPos.x * gameObject.transform.localScale.x),
            (GunPos.y)
        );
        Vector3 GunRelYOnly = new Vector3(0, PosRelToGun.y);
        Vector3 GunEnd = new Vector3(gameObject.transform.right.x * gameObject.transform.localScale.x, gameObject.transform.right.y * gameObject.transform.localScale.x);
        Vector3 FinalDir = new Vector3(GunEnd.x, GunEnd.y + UnityEngine.Random.Range(-GunAccuracy, GunAccuracy));
        //FUCK this. kill me.
        RaycastHit2D hit = Physics2D.Raycast(gameObject.transform.position + GunRelYOnly, FinalDir, UnityEngine.Mathf.Infinity, 1 << LayerMask.NameToLayer("Objects"), -UnityEngine.Mathf.Infinity, UnityEngine.Mathf.Infinity);
        RaycastHit2D hit2 = Physics2D.Raycast(gameObject.transform.position + GunRelYOnly, FinalDir, UnityEngine.Mathf.Infinity, 1 << LayerMask.NameToLayer("Bounds"), -UnityEngine.Mathf.Infinity, UnityEngine.Mathf.Infinity);
        RaycastHit2D hit3 = Physics2D.Raycast(gameObject.transform.position + GunRelYOnly, FinalDir, UnityEngine.Mathf.Infinity, 1 << LayerMask.NameToLayer("CollidingDebris"), -UnityEngine.Mathf.Infinity, UnityEngine.Mathf.Infinity);
        float HitGoal = float.PositiveInfinity;

        if (hit2){ HitGoal = hit2.distance; } //gets what is the shortest distance aka the closest hit
        if (hit) {if (HitGoal > hit.distance) HitGoal = hit.distance;}
        if (hit3 && FriendlyFire) {if (HitGoal > hit3.distance) HitGoal = hit3.distance;}

        //according to the shortest hit distance, hit.
        //probably a better way to do this but I can't seem to get Multiple-layer Raycasts working- and i'm sick of debugging this into DEVELOPMENT HELL.
        if (hit2) {if (hit2.distance == HitGoal){
            BulletImpactOnTarget(hit2.collider.gameObject, hit2.point, hit2.normal, true);
        }}
        if (hit) {if (hit.distance == HitGoal){
            BulletImpactOnTarget(hit.collider.gameObject, hit.point, hit.normal, true);
        }}
        if (hit3) {if (hit3.distance == HitGoal){
            BulletImpactOnTarget(hit3.collider.gameObject, hit3.point, hit3.normal);
        }}

        //shoot effect and sfx.
        ModAPI.CreateParticleEffect("Flash", gameObject.transform.position + PosRelToGun);
        if (GunSFX != null) NHCfunc.PlaySFX(GunSFX, gameObject.transform.position);
    }

    public void BulletImpactOnTarget(GameObject Target, Vector3 ImpactPoint, Vector3 ImpactNormal, bool Flash = false){ //when a bullet hits a target
        Target.gameObject.SendMessage("Shot", (object) new Shot(ImpactNormal, ImpactPoint, GunDamage), SendMessageOptions.DontRequireReceiver);
        if (Target.gameObject.GetComponent<Rigidbody2D>() != null){
            if (!(Target.gameObject.GetComponent<Rigidbody2D>().bodyType == RigidbodyType2D.Static)){
            Target.gameObject.GetComponent<Rigidbody2D>().velocity -= new Vector2(ImpactNormal.x * GunForce, ImpactNormal.y * GunForce);
            }
        }
        if (Flash){
            ModAPI.CreateParticleEffect("Flash", ImpactPoint);
        }
    }

    public void ChangeDir(int dir) //sets the direction to a int from -1 to 1.
    {
        gameObject.transform.localScale = new Vector2(UnityEngine.Mathf.Abs(gameObject.transform.localScale.x) * dir, gameObject.transform.localScale.y);
    }

    public void AniCheck(bool Reset = false)
    {
        if (Reset){
            AniFrameMax = AniSprites.Length;
            AniFrameTimeGoal = (UnityEngine.Time.fixedTime + AniFPS);
            AniFrame = 0;

            if (Health <= (InitHealth * 0.5f)){
            SpriteRend.sprite = AniSpritesHurt[0];
            }else{
            SpriteRend.sprite = AniSprites[0];
            }

            PhysBehav.RefreshOutline();
        }

        if (UnityEngine.Time.fixedTime > AniFrameTimeGoal){ //change frame
            AniFrameTimeGoal = (UnityEngine.Time.fixedTime + AniFPS); //simple clock based on global time and cross-checking it.

            if (!(AniFrame >= (AniFrameMax - 2) && (AniPlaysOnce))){
                AniFrame ++; //frame progression
                if (AniFrame >= (AniFrameMax - 1)){
                AniFrame = 0;
                }
            }else{
                if (AniState == "Death"){
                    gameObject.FixColliders();
                    AniFrameTimeGoal = float.PositiveInfinity;
                }
            }
            if (Health <= (InitHealth * 0.5f)){
            SpriteRend.sprite = AniSpritesHurt[AniFrame];
            }else{
            SpriteRend.sprite = AniSprites[AniFrame];
            }
            //UnityEngine.Debug.Log("Ani " + AniFrame);
            PhysBehav.RefreshOutline();

            if ((AniFrame == 1) && (AniState == "Gun")){
                CreateBullet();
            }
        }
    }
}
// Originally uploaded by 'Abyssal Studio'. Do not reupload without their explicit permission.
