using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using System.Linq;

public class NHCfunc
{
    public static Sprite[] LoadCharFrames(string Name, int Amount, bool HurtVari = false, int Scale = 1){
        Sprite[] tempArray = new Sprite[] {};
        for(int i = 0; i < (Amount + 1); i++)
        {
            if (i == Amount){
            tempArray = tempArray.Concat(new[] {ModAPI.LoadSprite("chars/char_human_col.png")}).ToArray();
            }else{
                if (HurtVari){
                tempArray = tempArray.Concat(new[] {ModAPI.LoadSprite("chars/" + Name + (i) + "_hurt.png", Scale)}).ToArray();
                }else{
                tempArray = tempArray.Concat(new[] {ModAPI.LoadSprite("chars/" + Name + (i) + ".png", Scale)}).ToArray();
                }
            }
        }
        
        return(tempArray);
    }

    public static void PlaySFX(AudioClip[] Audio, Vector3 Transform){
        AudioSource.PlayClipAtPoint(Audio[(int) UnityEngine.Random.Range(0, (Audio.Length - 1))], Transform);
    }

    public static Sprite LoadUISprite(string Name, Vector4 Border){ //gets a texture2D, wraps that into a new sprite and then sets it up for 9slicing : then returning the sprite.
        Texture2D TempUI = ModAPI.LoadTexture("ui/" + Name + ".png");
        Sprite TheSprite = Sprite.Create(TempUI, new Rect(0,0,TempUI.width,TempUI.height), new Vector2(0,0), AssetLoadup.PixPerUnit, 0, SpriteMeshType.FullRect, Border);
        return(TheSprite);
    }

    public static AudioClip[] LoadSFX(string Name, int Amount){ //according to the name as a sort of Prefix, and the amount... goes over all files in sfx/ and returns an AudioClip array.
        AudioClip[] tempAudioArray = new AudioClip[] {};
        for(int i = 0; i < (Amount); i++)
        {
            tempAudioArray = tempAudioArray.Concat(new[] {ModAPI.LoadSound("sfx/" + Name + (i) + ".mp3")}).ToArray();
        }
        return(tempAudioArray);
    }

    public static void PhysSetup(PhysicalBehaviour Phys, Rigidbody2D Rigi, float Mass){ //sets up the initial basic physics for the overhaul
        Phys.InitialMass = Mass;
        Phys.TrueInitialMass = Mass;
        Phys.HoldingPositions = new Vector3[] {};
        Rigi.constraints = RigidbodyConstraints2D.FreezeRotation;
    }

    public static GameObject CreateWindow(){ //creates a NHC ui window
        GameObject WindowObj = new GameObject("NHCWindow-" + UnityEngine.Random.Range(10000000,99999999));

        SpriteRenderer WindowSprite = WindowObj.gameObject.AddComponent<SpriteRenderer>();

        //WindowObj.transform.SetParent (Camera.main.gameObject.transform, true);
        WindowObj.layer = LayerMask.NameToLayer("UI");
        WindowSprite.sortingLayerName = "Decals";

        WindowSprite.sprite = AssetLoadup.UI_Window;
        WindowSprite.drawMode = SpriteDrawMode.Sliced;
        WindowSprite.size = new Vector2(5f,2f);

        RectTransform RectTran = WindowObj.AddComponent<RectTransform>();

        RectTran.anchoredPosition = new Vector2(0f, 0f);
        RectTran.sizeDelta= new Vector2(100, 100); 
        RectTran.localPosition = new Vector2(0,0);
        Debug.Log("NHC Window Created " + WindowObj.transform.position.x + " " + WindowObj.transform.position.y);
        
        NHCui UIcomp = WindowObj.AddComponent<NHCui>();
        UIcomp.FollowCam = true;
        UIcomp.ResizableWindow = true;
        UIcomp.UISize = new Vector2(5,2);

        return(WindowObj);
    }
}

// Originally uploaded by 'Abyssal Studio'. Do not reupload without their explicit permission.
