using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using System;

public class NHCui : MonoBehaviour
{
    public bool FollowCam = false;
    public bool ResizableWindow = false;
    public Vector2 UISize;
    public Vector2 UISizeMin = new Vector2(1f,1f);
    public float WindowBorderWidth = 0.18f;

    private Camera Cam;
    private RectTransform RectTran;
    private SpriteRenderer SpriteRend;
    private bool ClickReset = false;
    private int ClickHolding = 0;
    private int EdgeHolding = 0;
    private int MovingWindow = 0;
    private Vector3 WindowDragOffset = Vector3.zero;
    public Vector3 UIPosition = Vector3.zero;
    //private Collider2D Collider;

    private void Awake(){
        Cam = Camera.main;
        RectTran = this.gameObject.GetComponent<RectTransform>();
        SpriteRend = this.gameObject.GetComponent<SpriteRenderer>();
        //Collider = this.gameObject.AddComponent<Collider2D>();
        // 1 << LayerMask.NameToLayer("Objects")
    }

    private void Start(){
        SpriteRend.size = UISize;
    }

    private void Update(){
        //Input.GetMouseButtonDown(0)
        Vector3 MousePos = Cam.ScreenToWorldPoint(Input.mousePosition);

        if(ResizableWindow){
            if (SpriteRend.size != UISize) SpriteRend.size = UISize; //if resizable window, constantly update visual scale to variable.
        }

        if (Input.GetMouseButton(0)){ //made my own Click and Hold dedection cause I find over-engineering... "fun" :)
            if (
            (MousePos.x < (gameObject.transform.position.x + UISize.x)) && (MousePos.x > gameObject.transform.position.x) &&
            (MousePos.y < (gameObject.transform.position.y + UISize.y)) && (MousePos.y > gameObject.transform.position.y)){ //detect if mouse is in bounds of window without collider! raw math.
                if(!ClickReset){
                    ClickOnce(MousePos);
                }
                if (ClickHolding == 0) ClickHolding = 1; //simple 3-point comparison, to trigger Holding only when the click has Started within the "bounds"
                if (ClickHolding == 1){
                    if  ((MousePos.y > (gameObject.transform.position.y + UISize.y - WindowBorderWidth))){//is bar top AKA can move the window
                        if (MovingWindow == 0) {
                            MovingWindow = 1;
                            WindowDragOffset = new Vector3(
                                MousePos.x - gameObject.transform.position.x,
                                MousePos.y - gameObject.transform.position.y);
                        }
                    }else if (MovingWindow != 1){ //if not window top or moving then check for if it is edges
                        if ((MousePos.x < (gameObject.transform.position.x + UISize.x - WindowBorderWidth)) && (MousePos.x > gameObject.transform.position.x + WindowBorderWidth) && //determine border area
                        (MousePos.y < (gameObject.transform.position.y + UISize.y - WindowBorderWidth)) && (MousePos.y > gameObject.transform.position.y + WindowBorderWidth)){ //if border
                            if (EdgeHolding == 0)EdgeHolding = -1;
                        }else if (EdgeHolding == 0){ //if not border
                            EdgeHolding = 1;
                        }
                    }
                }

            }else{
                if (EdgeHolding == 0)
                EdgeHolding = -1;
                if (ClickHolding == 0)
                ClickHolding = -1;
                if (MovingWindow == 0)
                MovingWindow = -1;
            }

            if (MovingWindow == 1) WindowMovement(MousePos);
            if (EdgeHolding == 1){
            ClickHold(MousePos, true);
            }else if (ClickHolding == 1){
            ClickHold(MousePos, false);
            }

            ClickReset = true;
        }else{//mouse up
            ClickReset = false; //resets the click check stuff
            EdgeHolding = 0;
            ClickHolding = 0;
            MovingWindow = 0;
        }

        if (FollowCam){
            Vector2 GotoTrans = new Vector2( //move to be centered on the camera location.
                ((Cam.gameObject.transform.position.x - (UISize.x * 0.5f)) + UIPosition.x),
                ((Cam.gameObject.transform.position.y - (UISize.y * 0.5f)) + UIPosition.y));
            RectTran.localPosition = GotoTrans;
        }
    }

    public void WindowMovement(Vector3 MousePos){ //ran every tick the Top of the Window is being moved
        UIPosition = new Vector3((MousePos.x - Cam.gameObject.transform.position.x) - WindowDragOffset.x + (UISize.x * 0.5f),
        (MousePos.y - Cam.gameObject.transform.position.y) - WindowDragOffset.y + (UISize.y * 0.5f));
    }

    public void ClickOnce(Vector3 MousePos){
        Debug.Log("Window Clicked!!!!!!!!!");
    }

    public void ClickHold(Vector3 MousePos, bool IsBorder){
        Debug.Log("Click HOLD");
        if (ResizableWindow && IsBorder){

            Vector2 SizeTemp = new Vector2(((MousePos.x - gameObject.transform.position.x) + (WindowBorderWidth * 0.5f)),
                ((MousePos.y - gameObject.transform.position.y) + (WindowBorderWidth * 0.5f)));
            UISize = new Vector2 (
                Mathf.Clamp((Mathf.Abs(SizeTemp.x)),UISizeMin.x,999),
                Mathf.Clamp((Mathf.Abs(SizeTemp.y)),UISizeMin.y,999)
                );
        }
    }

    // private void OnMouseDown()
    // {
    //     Debug.Log("Clicked Window");
    // }
}
// Originally uploaded by 'Abyssal Studio'. Do not reupload without their explicit permission.
